	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

rand = $C0				; 32 bit random number generator

; keyboard
keyb_ptr		= $C4		; 16 bit
keyb_lastkey		= $C6
keyb_repeatcnt		= $C7
keyb_shift		= $C8
keyb_repeat_init	= 20		; constant
keyb_repeat		= 4		; constant

hs_scorelen		= 8		; length of score

board = $0130

; menu (title screen) animation
menu_animation_index	= $B0
menu_animation_count	= $B1

; game
curr_source		= $D0		; $00,$10,$20: that column is selected, $FF = no selection
curr_target		= $D1		; $00,$10,$20: that column is selected, $FF = no selection
active_column		= $D2		; $00,$10,$20: the currently "active" column (that is about to drop after the player's move)
curr_color		= $D3		; used for drawing blocks
merged			= $D4		; flag if dropped block has merged (0 = no, $FF = yes)
new_hs			= $D5		; flag if new high score
note_index		= $D6
first_line		= $D7		; flag if first line (if so, don't erase line above)
draw_selected		= $D8		; 0 = draw regular block, 9 = draw "selected" block
tutorial_page		= $D9
window_width		= $DA
window_height		= $DB
game_mode		= $DC		; 0 = normal mode, 1 = demo, 2 = tutorial
sound_enabled		= $DD		; 0 = enabled (default), non-zero: quiet
animation_enabled	= $DE		; 0 = enabled (default), non-zero: disabled 
graphics_mode		= $DF		; 0 = default, non-zero: petscii

chr_src			= $E0
col_dst			= $E2
chr_dst			= $E4
appear_src		= $E6

EMPTY_COLOR = $71
BACKGROUND_COLOR = $51
MAX_BLOCK = 16
GAME_OVER_PANEL_COLOR = $06
score_screen_addr = $0C0F
TITLE_SCREEN_COLOR = 4

start
	ldx #50				; pal value (frames per second)
	lda $FF07
	and #$40
	beq *+4
	ldx #60				; ntsc value (frames per second)
	stx time_end+6
	;
	lda #$00
	sta sound_enabled
	sta graphics_mode
	;
title_screen
	sei
	sta $FF3F
	;
	jsr sync_bottom
	lda #$50+TITLE_SCREEN_COLOR
	sta $FF19
	lda #$71
	sta $FF15
	lda #$40+TITLE_SCREEN_COLOR
	sta $FF16
	lda #$31
	sta $FF17
	;
	lda #$0B
	sta $FF06
	;
	jsr init_graphics
	;
	; ---
	;
	lda $FF19			; fill $0800 with background color
	and #$7F
	jsr clear_screen_1
	;
	jsr reset_menu_animation
	;
	; ---
	;
	ldx #$ff
tl6	inx
	cpx #$07			; write at least a single zero
	beq tl7
	lda HighScore,x			; keep looping until first non-zero digit
	beq tl6
	;
tl7	lda HighScore,x
	clc
	adc zero_index
	sta hs_dest,x
	inx
	cpx #hs_scorelen
	bne tl7
	;
	lda #$1B
	sta $FF06
	;
	jsr wait_for_key_release
	;
	lda #menu_key_table & 255
	ldx #menu_key_table >> 8
	jmp keyboard

wait_for_key_release
	lda #$02
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wait_for_key_release
	rts
	
menu_animation
	lda menu_animation_count
	bne ma1
	;
	inc menu_animation_index
	ldx menu_animation_index
	lda menu_animation_counts,x
	sta menu_animation_count 
	;
ma1	dec menu_animation_count
	ldx menu_animation_index
	lda menu_animation_call_lo,x
	sta menu_animation_call+1
	lda menu_animation_call_hi,x
	sta menu_animation_call+2
menu_animation_call
	jmp menu_animation_call
	
menu_animation_counts
	db 1
	db 9
	db 77
	db 1, 11
	db 1, 8
	db 1, 5
	db 1
	db 83
	db 1
	db 77
	db 1
	db 20
	db 1
	db 77
	db 1
	db 20
	db 1
	
menu_animation_call_lo
	db setup_fill_area & 255
	db fill_area & 255
	db draw_stack_char & 255
	db reset_123_block & 255
	db drop_123_block & 255
	db reset_123_block & 255
	db drop_123_block & 255
	db reset_123_block & 255
	db drop_123_block & 255
	db reset_letters & 255
	db write_letter & 255
	db reset_stack_chars & 255
	db draw_stack_char & 255
	db reset_letters_2 & 255
	db write_letter & 255
	db reset_stack_chars & 255
	db draw_stack_char & 255
	db reset_letters_1 & 255
	db write_letter & 255
	db loop_menu_animation & 255
	
menu_animation_call_hi
	db setup_fill_area >> 8
	db fill_area >> 8 
	db draw_stack_char >> 8
	db reset_123_block >> 8
	db drop_123_block >> 8
	db reset_123_block >> 8
	db drop_123_block >> 8
	db reset_123_block >> 8
	db drop_123_block >> 8
	db reset_letters >> 8
	db write_letter >> 8
	db reset_stack_chars >> 8
	db draw_stack_char >> 8
	db reset_letters_2 >> 8
	db write_letter >> 8
	db reset_stack_chars >> 8
	db draw_stack_char >> 8
	db reset_letters_1 >> 8
	db write_letter >> 8
	db loop_menu_animation >> 8
	
reset_letters
	lda #title_text & 255
	sta chr_src
	lda #title_text >> 8
	sta chr_src+1
	;
	ldx #$3A
	lda #$0E
	jmp set_dst
	
reset_letters_1
	ldx #title_1 & 255
	ldy #title_1 >> 8
	bne res_2
	;
reset_letters_2
	ldx #title_2 & 255
	ldy #title_2 >> 8
	;
res_2	stx chr_src
	sty chr_src+1
	;
	ldx #$DA
	lda #$0E
	jmp set_dst
	
write_letter
	ldy #$00
	lda (chr_src),y
	beq next_line
	ora invert_chars 
	sta (chr_dst),y
	;
	lda #1
	db $2C
next_line
	lda #60
	jsr ptrs_add_a
	lda #1
	jsr src_add_a
	rts
	
reset_123_block
	lda #$1A
	sta drop_123_block+1
	lda #$0C
	sta drop_123_block+3
	;
	dec block_123+1
	rts
	
drop_123_block
	ldx #$19
	lda #$0C
	jsr set_dst
	;
block_123
	ldy #$04
	lda block_colors,y
	sta curr_color
	;
	jsr get_number_char_addr
	;
	ldx #$02
d12	ldy #$08
d11	lda (chr_src),y
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	dey
	bpl d11
	;
	jsr ptrs_add_40
	;
	lda #18
	jsr src_add_a
	;
	dex
	bpl d12
	;
	; ---
	;
	lda drop_123_block+1
	cmp #$19
	beq d0
	sec
	sbc #40
	tax
	lda drop_123_block+3
	sbc #0
	jsr set_dst
	ldy #9
d2	lda space_char
	sta (chr_dst),y
	lda $087C
	sta (col_dst),y
	dey
	bpl d2
	;
	; ---
	;
d0	ldy #9
d1	lda space_char
	sta $0C1A,y
	sta $0C1A+40,y
	sta $0C1A+80,y
	lda $0819
	sta $081A,y
	sta $081A+40,y
	sta $081A+80,y
	dey
	bpl d1
	;
	lda drop_123_block+1
	clc
	adc #40
	sta drop_123_block+1
	lda drop_123_block+3
	adc #0
	sta drop_123_block+3
	;
	rts
	
reset_stack_chars
	ldx #$00
	stx draw_stack_char+1
	;
	ldx #$4C+$80
	ldy #$50+TITLE_SCREEN_COLOR+8
	;
	lda dsch0+1
	cmp #$4C
	beq var2
	;
	ldx #$4C
	ldy #$60+TITLE_SCREEN_COLOR+8
	;
var2	stx dsch0+1
	sty dsch1+5
	rts
	
draw_stack_char
	ldy #$00
	lda draw_stack_char_pos,y
	tax
	lda draw_stack_char_pos+1,y
	jsr set_dst
	;
	iny
	iny
	sty draw_stack_char+1
	;
	ldy #$00
	;
	lda graphics_mode
	beq dsch1
	;
dsch0	lda #$4C
	sta (chr_dst),y
	lda #$04
	sta (col_dst),y
	rts
	;
dsch1	lda #$27
	sta (chr_dst),y
	lda #$60+TITLE_SCREEN_COLOR+8
	sta (col_dst),y
	rts
	
draw_stack_char_pos
	dw $0CA7
	dw $0CA6
	dw $0CA5
	dw $0CA5+40
	dw $0CA5+80 
	dw $0CA5+120
	dw $0CA5+160
	dw $0CA5+161
	dw $0CA5+162
	dw $0CA5+202
	dw $0CA5+242
	dw $0CA5+282
	dw $0CA5+322
	dw $0CA5+321
	dw $0CA5+320
	;
	dw $0CA9
	dw $0CAA
	dw $0CAB
	dw $0CAA+40
	dw $0CAA+80
	dw $0CAA+120
	dw $0CAA+160
	dw $0CAA+200
	dw $0CAA+240
	dw $0CAA+280
	dw $0CAA+320
	;
	dw $0CAD
	dw $0CAD+40
	dw $0CAD+80
	dw $0CAD+120
	dw $0CAD+160
	dw $0CAD+200
	dw $0CAD+240
	dw $0CAD+280
	dw $0CAD+320
	dw $0CAE
	dw $0CAF
	dw $0CAF+40
	dw $0CAF+80
	dw $0CAF+120
	dw $0CAF+160
	dw $0CAF+200
	dw $0CAF+240
	dw $0CAF+280
	dw $0CAF+320
	dw $0CAE+160
	;
	dw $0CB3
	dw $0CB2
	dw $0CB1
	dw $0CB1+40
	dw $0CB1+80
	dw $0CB1+120
	dw $0CB1+160
	dw $0CB1+200
	dw $0CB1+240
	dw $0CB1+280
	dw $0CB1+320
	dw $0CB2+320
	dw $0CB3+320
	;
	dw $0CB5
	dw $0CB5+40
	dw $0CB5+80
	dw $0CB5+120
	dw $0CB5+160
	dw $0CB5+200
	dw $0CB5+240
	dw $0CB5+280
	dw $0CB5+320
	dw $0CB7
	dw $0CB7+40
	dw $0CB7+80
	dw $0CB7+120
	dw $0CB6+160
	dw $0CB7+200
	dw $0CB7+240
	dw $0CB7+280
	dw $0CB7+320
	
reset_menu_animation
	ldx #$FF
	stx menu_animation_index
	inx
	stx menu_animation_count
	stx draw_stack_char+1
	;
	lda #$04
	sta block_123+1
	rts
	
loop_menu_animation
	lda menu_animation_index
	sec
	sbc #$09
	sta menu_animation_index
	rts
	
setup_fill_area
	lda #$ED
	sta fill_area+1
	lda #$0D
	sta fill_area+3
	lda #0
	sta fa_h+1
	lda #13
	sta fa_w+1	
	;
	lda $FF16
	and #$7F
	sta fa_color+1
	;
fill_area	
	ldx #$7C
	lda #$0C
	jsr set_dst
	;
fa_h	ldx #$12
fa_w	ldy #31
is1	lda space_char
	sta (chr_dst),y
fa_color
	lda #$00
	sta (col_dst),y
	dey
	bpl is1
	;
	jsr ptrs_add_40
	dex
	bpl fa_w
	;
	inc fa_h+1
	inc fa_h+1
	inc fa_w+1
	inc fa_w+1
	;
	lda fill_area+1
	sec
	sbc #41
	sta fill_area+1
	lda fill_area+3
	sbc #0
	sta fill_area+3
	rts
	
init_game
	ldx #$00			; initialize game variables
	stx active_column
	dex
	stx curr_source
	stx curr_target
	;
	jsr clear_score
	;
	ldx #$06
	lda #$00
ct1	sta time,x			; reset time
	dex
	bpl ct1
	;
	jsr init_board
	;
;	lda #3 
;	sta board
;	lda #3
;	sta board+$10
;	lda #2
;	sta board+$20
;	;
;;	lda #0
;;	sta board+$05
;;	lda #0
;;	sta board+$15
;;	sta board+$25
;;	;
;;	lda #0
;;	sta board+$06
;;	lda #0
;;	sta board+$16
;;	lda #3
;;	sta board+$26
;;	;
;;	lda #4
;;	sta board+$16
;;	;	
;	lda #1 
;	sta board+$02
;	lda #2 
;	sta board+$03
;	lda #10
;	sta board+$04
;	lda #11
;	sta board+$05
;	lda #12
;	sta board+$06
;	;
;	lda #7
;	sta board+$12
;	lda #8
;	sta board+$13
;	lda #9
;	sta board+$14
;	lda #10
;	sta board+$15
;	lda #11
;	sta board+$16
;	;
;	lda #1
;	sta board+$22
;	lda #2
;	sta board+$23
;	lda #14
;	sta board+$24
;	lda #15
;	sta board+$25
;	lda #16
;	sta board+$26
	
;	jsr draw_full_board
;	;
;	jsr wait_space
;	;
;	ldx #$00
;	jsr drop
;	jsr draw_full_board
;	;
;	ldx #$10
;	jsr drop
	rts	

setup_game_screen
	jsr sync_bottom
	lda #BACKGROUND_COLOR
	sta $FF19
	lda #$71
	sta $FF15
	lda #$41
	sta $FF16
	lda #$00
	sta $FF17
	;
	lda #$0B
	sta $FF06
	;
	; ---
	;
	jsr draw_full_board
	;
	sei
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	lda #$AB
	sta $FF0B
	asl $FF09
	cli
	;
	lda #$1B
	sta $FF06
	;
	rts

clear_screen
	lda #BACKGROUND_COLOR		; fill $0800 with background color
clear_screen_1
	ldy #$08
	sty chr_dst+1
	ldy #$00
	sty chr_dst
	;
	ldx #$03
il2	sta (chr_dst),y
	iny
	bne il2
	inc chr_dst+1
	dex
	bpl il2
	;
	ldx #$03
	lda space_char			; and $0C00 with spaces
il4	sta (chr_dst),y
	iny
	bne il4
	inc chr_dst+1
	dex
	bpl il4
	;
	rts
	
tutorial_next_page
	lda tutorial_page		; are we on the
	cmp #$09			; last page? (number of pages)
	bne tnp1
	;
	jmp title_screen		; reached, back to title
	;
tnp1	inc tutorial_page
	bne draw_tutorial_page 
	;
start_tutorial
	jsr init_game
	;
	lda #2
	sta board
	lda #1
	sta board+$10
	sta board+$20
	;
	lda #0
	sta board+5
	lda #4
	sta board+6
	;
	lda #3
	sta board+$15
	lda #4
	sta board+$16
	;
	lda #2
	sta board+$24
	sta board+$26
	lda #1
	sta board+$25
	;
	jsr setup_game_screen
	;
	ldx #$10
	stx active_column
	;
	lda #$02
	sta game_mode
	;
	lda #$00
	sta tutorial_page
	;
draw_tutorial_page
	ldx #$78
	lda #$0C
	jsr set_dst
	;
	ldx #5
tt4	ldy #13
tt3	lda space_char
	sta (chr_dst),y
	lda top_background_color
	sta (col_dst),y
	dey
	bpl tt3
	;
	jsr ptrs_add_40
	;
	dex
	bpl tt4
	;
	ldx #5
tt41	ldy #3
tt31	lda space_char
	sta (chr_dst),y
	lda #BACKGROUND_COLOR
	sta (col_dst),y
	dey
	bpl tt31
	;
	jsr ptrs_add_40
	;
	dex
	bpl tt41
	;
	jsr draw_column_1
	;
	ldx active_column
	jsr draw_selected_block
	;
	; ---
	;
	ldx tutorial_page		; set pointer to the data for the current page
	lda tutorial_pages_lo,x
	sta chr_src
	lda tutorial_pages_hi,x
	sta chr_src+1
	;
	ldy #$00
	lda (chr_src),y			; first byte of data is window width
	sta window_width
	iny
	lda (chr_src),y			; second byte is window_height
	sta window_height
	;
	lda #$02
	jsr src_add_a
	;
	; ---
	;
	ldx #$17
	lda space_char			; erase old "press space" text
	sta $0FD1,x
	dex
	bpl *-4
	stx tutorial_loop+1		; reset "press space" timer
	;
	; ---
	;
	jsr sync
	;
	ldx #$78			; screen dest pointer is hardcoded to $0C78
	lda #$0C
	jsr set_dst
	;
	ldy #$00
	lda border_chars
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
tw1	iny
	lda border_chars+1
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	cpy window_width
	bne tw1
	;
	iny
	lda border_chars+2
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
	jsr ptrs_add_40
	;
	ldx #$00
	;
tw3	ldy #$00
	lda border_chars+3
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
tw2	iny
	lda space_char
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	cpy window_width
	bne tw2
	;
	iny
	lda border_chars+4
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
	jsr ptrs_add_40
	;
	inx
	cpx window_height
	bne tw3
	;
	ldy #$00
	lda border_chars+5
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
tw4	iny
	lda border_chars+6
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	cpy window_width
	bne tw4
	;
	iny
	lda border_chars+7
	sta (chr_dst),y
	lda tutorial_border_color
	sta (col_dst),y
	;
	; ---
	;
	jsr sync
	;
	ldx #$A1			; start position ($0CA1)
	lda #$0C
	jsr set_dst
	;
	ldx window_height
	;
tt2	ldy window_width
	dey
tt1	lda (chr_src),y
	ora invert_chars
	sta (chr_dst),y
	lda tutorial_color
	sta (col_dst),y
	dey
	bpl tt1
	;
	jsr ptrs_add_40
	;
	lda window_width
	jsr src_add_a
	;
	dex
	bne tt2
	;
	ldx tutorial_page
	lda tutorial_steps_lo,x
	sta tutorial_call+1
	lda tutorial_steps_hi,x
	sta tutorial_call+2
	;
tutorial_call
	jsr tutorial_call 
	;
	lda #tutorial_key_table & 255
	ldx #tutorial_key_table >> 8
	jmp keyboard
	
tutorial_steps_lo
	db tutorial_step_1 & 255
	db tutorial_step_2 & 255 
	db tutorial_step_3 & 255 
	db tutorial_step_4 & 255 
	db tutorial_step_5 & 255 
	db tutorial_step_6 & 255
	db tutorial_step_7 & 255
	db tutorial_step_8 & 255
	db tutorial_step_9 & 255
	db tutorial_step_10 & 255
	
tutorial_steps_hi
	db tutorial_step_1 >> 8
	db tutorial_step_2 >> 8
	db tutorial_step_3 >> 8
	db tutorial_step_4 >> 8
	db tutorial_step_5 >> 8
	db tutorial_step_6 >> 8
	db tutorial_step_7 >> 8
	db tutorial_step_8 >> 8
	db tutorial_step_9 >> 8
	db tutorial_step_10 >> 8
	
tutorial_step_1
tutorial_step_2
tutorial_step_5
tutorial_step_7
tutorial_step_10
	rts
	
tutorial_step_3
	ldx #$20
	stx curr_source
	;
	jmp tut_21	
	
tutorial_step_4
	ldx #$24
	lda board,x
	pha
	lda #$00
	sta board,x
	jsr draw_block
	;
	pla
	ldx #$11
	sta board,x
	jmp drop
	
tutorial_step_6
	jmp tut_5_default_colors
	
tutorial_step_8
	ldx active_column
	jsr drop
	jsr gen_block_next
	;
	ldx #$20
	stx active_column
	jmp draw_selected_block
	
tutorial_step_9
	ldx active_column
	jsr drop
	jmp gen_block_next
	
tutorial_loop
	ldx #$FF			; after about 5 seconds...
	beq tl_01
	dex
	stx tutorial_loop+1
	bne tl_01
	;
	ldx #$D1			; write "press space" prompt on screen
	lda #$0F
	jsr set_dst
	;
	ldx #press_space & 255
	lda #press_space >> 8
	ldy #$17
	jsr copy_text
	;
tl_01	ldx tutorial_page
	lda tutorial_loops_lo,x
	sta tutorial_loop_call+1
	lda tutorial_loops_hi,x
	sta tutorial_loop_call+2
	;
tutorial_loop_call
	jmp tutorial_call
	
tutorial_loops_lo
	db tutorial_loop_1 & 255
	db tutorial_loop_2 & 255 
	db tutorial_loop_3 & 255 
	db tutorial_loop_4 & 255 
	db tutorial_loop_5 & 255 
	db tutorial_loop_6 & 255
	db tutorial_loop_7 & 255
	db tutorial_loop_8 & 255
	db tutorial_loop_9 & 255
	db tutorial_loop_10 & 255
	
tutorial_loops_hi
	db tutorial_loop_1 >> 8
	db tutorial_loop_2 >> 8
	db tutorial_loop_3 >> 8
	db tutorial_loop_4 >> 8
	db tutorial_loop_5 >> 8
	db tutorial_loop_6 >> 8
	db tutorial_loop_7 >> 8
	db tutorial_loop_8 >> 8
	db tutorial_loop_9 >> 8
	db tutorial_loop_10 >> 8
	
tutorial_loop_1
tutorial_loop_4
tutorial_loop_8
tutorial_loop_9
tutorial_loop_10
tl_ret	rts
	
tutorial_loop_2
	ldx #$1F
	inx
	stx tutorial_loop_2+1
	txa
	and #$0F
	bne tl_ret
	;
	txa
	and #$20
	beq tut_21
	;
	lda #$02
	ldy #$00
	beq tut_22
	;
tut_21	lda #$00
	ldy #$02
tut_22	sta board+$14
	sty board+$24
	;
	ldx #$14
	jsr draw_block
	ldx #$24
	jmp draw_block
	
tutorial_loop_3
tutorial_loop_6
	ldx #$00
	inx
	stx tutorial_loop_3+1
	txa
	and #$0F
	bne tl3
	;
	txa
	and #$10
	beq tl31
	;
	ldx curr_source
	jmp draw_source_selection
	;
tl31	ldx curr_source
	jmp clear_source_selection
	;
tl3	rts
	
tutorial_loop_5
	ldx #$00
	inx
	stx tutorial_loop_5+1
	txa
	and #$0F
	bne tl51
	;
	txa
	and #$10
	beq tut_5_default_colors
	;
	ldx #$06
	lda #$22
	jsr color_block
	;
	ldx #$14
	lda #$21
	jsr color_block
	;
	ldx #$25
	lda #$24
	jsr color_block
	;
tl51	rts

tut_5_default_colors
	ldx #$06
	jsr color_block_default
	;
	ldx #$14
	jsr color_block_default
	;
	ldx #$25
	;
	; X = board index
color_block_default
	lda board,x
	tay
	lda block_colors,y		; look up default color
	;
	; X = board index
	; A = color
color_block
	sta curr_color
	;	
	jsr get_block_screen_addr
	;
	lda #1
	jsr ptrs_add_a
	;
	ldx #$02
cob2	ldy #$08
	lda curr_color
cob1	sta (col_dst),y
	dey
	bpl cob1
	;
	jsr ptrs_add_40
	dex
	bpl cob2
	rts
	
tutorial_loop_7
	ldx #$00
	inx
	stx tutorial_loop_7+1
	txa
	and #$0F
	bne tl51
	;
	txa
	and #$10
	beq tut_7_default_colors
	;
	ldx #$10			; board position
	lda #$41			; shaded color
	jmp color_block

tut_7_default_colors
	ldx #$10
	jmp color_block_default

start_demo
	jsr InitRandom
	;
	jsr init_game
	;
	jsr setup_game_screen
	;
	ldx #$03
sd1	lda demo,x
	ora invert_chars
	sta $0C00,x
	sta $0C24,x
	dex
	bpl sd1
	;
	lda #$01
	bne gm1

start_game
	jsr InitRandom
	;
	jsr init_game
	;
	jsr setup_game_screen
	;
	lda #$00
gm1	sta game_mode
	;
game_loop
	jsr display_score
	;
	ldx active_column
	jsr draw_selected_block
	;
	lda game_mode
	beq gl1
	;
	jmp auto_move
	;
gl1	lda #game_key_table & 255
	ldx #game_key_table >> 8
	jmp keyboard
	
quit	
	sei
	;
	jsr sync_bottom
	;
	lda #$0B
	sta $FF06
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	lda #$00
	sta $FF11
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	;
	sta $FF3E
	;
	lda #$93
	jsr $FFD2
	;
	jsr sync_bottom
	;
	lda #$1B
	sta $FF06
	;
	jmp $8003

wait_space	
np1	lda #$7F			; wait for space to be pressed...
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10
	bne np1
	;
np2	lda #$7F			; ...and released.
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10
	beq np2
	rts
	
deselect
	ldx curr_source
	bmi des1
	;
	jsr clear_source_selection
	;
	ldx #$FF			; clear selection
	stx curr_source
	;
des1	jmp game_loop
	
press_1
	ldx #$00			; X = column index
	db $2C
press_2
	ldx #$10
	db $2C
press_3
	ldx #$20
	;
	cpx curr_source			; is the dest column same as the current?
	bne pr1
	;
	jsr clear_source_selection
	;
	ldx #$FF			; yes, clear selection and do nothing
	stx curr_source
	jmp game_loop
	;
pr1	lda curr_source			; is there a current selection?
	bpl make_move			; if so, the player is making a move
	;
	lda board+$6,x			; this column would be selected, but first check if this column is empty
	beq pr3				; if yes, do nothing - can't be selected
	;
pr2	stx curr_source			; make this the current selection and we're done
	;
	jsr draw_source_selection
	;
pr3	jmp game_loop
	
make_move
	txa				; X = dest column
	pha
	;
	ldx curr_source
	inx
mm1	inx				; find the topmost block
	lda board,x			; keep going while 0
	beq mm1
	;
	sta mm2+1			; save block to be moved
	;
	lda #$00			; erase block from board...
	sta board,x
	;
	jsr sync
	jsr draw_block			; and from screen
	;
	pla
	tax
	inx
	;
mm2	lda #$00
	sta board,x			; place block
	;
	jsr drop
	;
	lda #$FF			; clear current selection and we're done
	sta curr_source
	;
	; --- game over check
	;                    
	lda board+$01			; if any of these positions have a block, then that column has overflown (full)
	ora board+$11
	ora board+$21
	bne game_over
	;
drop_active
	lda curr_source			; check if something is currently selected
	bmi da1
	;
	jsr clear_source_selection	; yes, clear selection
	;
	ldx #$FF
	stx curr_source
	;
da1	ldx active_column
	jsr drop
	;
	; --- game over check
	;                    
	lda board+$01			; if any of these positions have a block, then that column has overflown (full)
	ora board+$11
	ora board+$21
	bne game_over
	;       
	jsr gen_block_next	
	;
	jmp game_loop
	
gen_block_next
	ldx active_column
	jsr generate_top_block
	;
	lda animation_enabled		; skip appear animation if animations are turned off
	bmi skip_aa
	;
	jsr appear_anim			; make the current block appear
	;
skip_aa	jsr sync
	ldx active_column
	jsr draw_block
	;
	lda active_column		; go to next column
	clc
	adc #$10
	cmp #$30
	bne no_column_wrap
	;
	lda #$00
no_column_wrap
	sta active_column
	rts
	
game_over
	ldx #$00
	stx new_hs			; flag "no new highscore"
	;
	lda game_mode			; in demo mode, don't keep track of high scores
	bne no_new_highscore
	;
hs1	lda Score,x
	cmp HighScore,x
	bcc no_new_highscore
	bne new_highscore
	;
	inx
	cpx #hs_scorelen
	bne hs1
	beq no_new_highscore		; exactly equal
	
new_highscore
	ldx #hs_scorelen-1
nh1	lda Score,x
	sta HighScore,x
	dex
	bpl nh1
	;
	dec new_hs			; flag new high score!
no_new_highscore
	;
	ldx #$41
	jsr color_background
	;
	ldx #$31
	jsr color_background
	;
	ldx #$21
	jsr color_background
	;
	ldx #$11
	jsr color_background
	;
	; ---
	;
	jsr sync
	;
	lda #$6E
	sta chr_dst
	sta col_dst
	lda #$0D
	sta chr_dst+1
	and #$FB
	sta col_dst+1
	;
	lda #GAME_OVER_PANEL_COLOR
	ldx graphics_mode
	bne *+4
	ora #$08
	sta curr_color
	;
	; --- top line
	;
	ldy #$00
	lda border_chars		; top/left corner
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	;
go1	lda border_chars+1		; top line
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	cpy #26
	bne go1
	;
	lda border_chars+2		; top/right
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	;
	jsr ptrs_add_40
	;
	; --- middle
	;
	ldx #$04
	lda new_hs
	beq *+4
	ldx #$07
	;
go3	ldy #$00
	lda border_chars+3		; left side
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	;
go2	lda space_char			; middle
	sta (chr_dst),y
	lda #GAME_OVER_PANEL_COLOR
	sta (col_dst),y
	iny
	cpy #26
	bne go2
	;
	lda border_chars+4		; right side
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y 
	;
	jsr ptrs_add_40
	;
	dex
	bpl go3
	;
	; --- bottom line
	;
	ldy #$00
	lda border_chars+5		; bottom/left
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	;
go4	lda border_chars+6		; bottom
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	cpy #26
	bne go4
	;
	lda border_chars+7		; bottom/right
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	;
	; --- text
	;
	ldx #$08
go9	lda game_over_text,x
	ora invert_chars
	sta $0D9F,x
	;
	lda space_char
	sta score_screen_addr,x		; erase "old" score
	;
	dex
	bpl go9
	;
	ldx #$09
go91	lda play_time,x
	ora invert_chars
	sta $0DE7,x
	dex
	bpl go91
	;
	ldx #$00
	ldy #$00
go6	lda time,x
	clc
	adc zero_index			; convert to numeric characters
	sta $0DF8,y
	iny
	cpy #$02
	beq go5
	cpy #$05
	bne go7
go5	lda #":"
	ora invert_chars
	sta $0DF8,y
	iny
go7	inx
	cpx #$06
	bne go6
	;
	ldx #$0B
go71	lda final_score,x
	ora invert_chars
	sta $0E37,x
	dex
	bpl go71
	;
	ldx #$ff
gc2	inx
	cpx #$07			; write at least a single zero
	beq gc3
	lda Score,x			; keep looping until first non-zero digit
	beq gc2
	;
gc3	lda Score,x
	clc
	adc zero_index			; convert to numeric characters
	sta $0E48,x
	inx
	cpx #hs_scorelen
	bne gc3
	;
	; --- 
	;
	lda new_hs
	beq go8
	;
	ldx #14
gc1	lda congrats1,x
	ora invert_chars
	sta $0E8C,x
	lda congrats2,x
	ora invert_chars
	sta $0EB4,x
	;
	dex
	bpl gc1
	;
go8	jsr wait_space
	;
	jmp title_screen
	
color_background
	stx curr_color			; x = color to set
	stx cb52+1
	txa
	;
	ldy graphics_mode
	bne cb0
	;
	ora #$08
	;
cb0	sta cb51+1
	sta cb41+1
	;
	lda $0800
	sta cb61+1
	ora #$08
	sta cb62+1
	;
	jsr sync_bottom
	;
	txa
	sta $FF19 			; set border color
	sec
	sbc #$10
	sta $FF16			; and multi-color (used for shadow characters)
	;
	ldy #39
	lda curr_color
cb1	sta $0800,y
	sta $0BC0,y
	;
	ldx graphics_mode
	bne cb11
	;
	sta $0828,y
	;
cb11	dey
	bpl cb1
	;
	ldy #3
cb2	sta $0850-40*1,y
	sta $0850+40*0,y
	sta $0850+40*1,y
	sta $0850+40*2,y
	sta $0850+40*3,y
	sta $0850+40*4,y
	sta $0850+40*5,y
	sta $0850+40*6,y
	sta $0850+40*7,y
	sta $0850+40*8,y
	sta $0850+40*9,y
	sta $0850+40*10,y
	sta $0850+40*11,y
	sta $0850+40*12,y
	sta $0850+40*13,y
	sta $0850+40*14,y
	sta $0850+40*15,y
	sta $0850+40*16,y
	sta $0850+40*17,y
	sta $0850+40*18,y
	sta $0850+40*19,y
	sta $0850+40*20,y
	sta $0850+40*21,y
	dey
	bpl cb2
	;
	ldy #$00
	ldx graphics_mode
	beq cb3
	ldy #$01
cb3	sta $0872-40*1,y
	sta $0872+40*0,y
	sta $0872+40*1,y
	sta $0872+40*2,y
	sta $0872+40*3,y
	sta $0872+40*4,y
	sta $0872+40*5,y
	sta $0872+40*6,y
	sta $0872+40*7,y
	sta $0872+40*8,y
	sta $0872+40*9,y
	sta $0872+40*10,y
	sta $0872+40*11,y
	sta $0872+40*12,y
	sta $0872+40*13,y
	sta $0872+40*14,y
	sta $0872+40*15,y
	sta $0872+40*16,y
	sta $0872+40*17,y
	sta $0872+40*18,y
	sta $0872+40*19,y
	sta $0872+40*20,y
	sta $0872+40*21,y
	iny
	cpy #$06
	bne cb3
	;
	ldx #$44
	lda #$09
	jsr set_dst
	;
	ldx #14
cb4	ldy #0
cb41	lda #$00
	sta (col_dst),y
	ldy #10
	sta (col_dst),y
	ldy #20
	sta (col_dst),y
	;
	jsr ptrs_add_40
	dex
	bpl cb4
	;
	;
	; ---
	;
	ldx #$54
	lda #$08
	jsr set_dst
	;
	ldx #5
cb6	ldy #29
cb5	lda (col_dst),y
cb61	cmp #$00
	beq cb52
cb62	cmp #$00
	bne cb53
	;
cb51	lda #$00
	db $2C
cb52	lda #$00
	sta (col_dst),y
	;
cb53	dey
	bpl cb5
	;
	jsr ptrs_add_40
	dex
	bpl cb6
	;
	; ---
	;
	ldy #29
	lda cb41+1
cb7	sta $0B9C,y
	dey
	bpl cb7
	;
	rts

copy_text
	stx chr_src
	sta chr_src+1
	;
	sty cot2+1
	dey
	;
cot1	lda (chr_src),y
	ora invert_chars
	sta (chr_dst),y
	dey
	bpl cot1
	;
cot2	lda #$00
	jmp ptrs_add_a
	
toggle_sound
	jsr clear_status_line
	;
	ldx #$CF
	lda #$0F
	jsr set_dst
	;
	ldx #sound_text & 255
	lda #sound_text >> 8
	ldy #$06
	jsr copy_text
	;
	lda sound_enabled
	eor #$FF
	sta sound_enabled
	;
write_on_off
	and #$03
	tax
	;
	ldy #$00
ts2	lda on_off_text,x
	ora invert_chars
	sta (chr_dst),y
	inx
	iny
	cpy #$03
	bne ts2
	;
	lda #100
	sta message_delay+1
	;
	jmp game_loop
	
toggle_animation
	jsr clear_status_line
	;
	ldx #$CD
	lda #$0F
	jsr set_dst
	;
	ldx #animation_text & 255
	lda #animation_text >> 8
	ldy #10
	jsr copy_text
	;
	lda animation_enabled
	eor #$FF
	sta animation_enabled
	;
	jmp write_on_off
	
toggle_graphics
	lda graphics_mode
	eor #$FF
	sta graphics_mode
	;
	jsr sync_bottom
	;
	lda #$0B
	sta $FF06
	;
	jsr draw_full_board
	;
	ldx #$CB
	lda #$0F
	jsr set_dst
	;
	ldx #graphics_text & 255
	lda #graphics_text >> 8
	ldy #10
	jsr copy_text
	;
	lda graphics_mode
	beq tg0
	;
	ldx #graphics_petscii & 255
	lda #graphics_petscii >> 8
	bne tg1
	;
tg0	ldx #graphics_custom & 255
	lda #graphics_custom >> 8
tg1	ldy #$07
	jsr copy_text
	;
	lda #100
	sta message_delay+1
	;
	jsr sync_bottom
	;
	lda #$1B
	sta $FF06
	;
	jmp game_loop
	
init_graphics
	lda graphics_mode
	beq gr1
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	;
	lda #petscii_number_chars_lo & 255
	sta ncl+1
	lda #petscii_number_chars_lo >> 8
	sta ncl+2
	;
	lda #petscii_number_chars_hi & 255
	sta nch+1
	lda #petscii_number_chars_hi >> 8
	sta nch+2
	;
	ldx #(gfx_petscii-gfx_custom)-1
	lda gfx_petscii,x
	sta gfx_data,x
	dex
	bpl *-7
	;
	bmi gr2
	
gr1	lda $FF07
	and #$40
	ora #$98
	sta $FF07
	;
	lda #$00
	sta $FF12
	lda #charset >> 8
	sta $FF13
	;
	lda #number_chars_lo & 255
	sta ncl+1
	lda #number_chars_lo >> 8
	sta ncl+2
	;
	lda #number_chars_hi & 255
	sta nch+1
	lda #number_chars_hi >> 8
	sta nch+2
	;
	ldx #(gfx_petscii-gfx_custom)-1
	lda gfx_custom,x
	sta gfx_data,x
	dex
	bpl *-7
	;
gr2	lda stack_background_color
	sta block_colors
	;
	rts

auto_move_values
	db 0,0,0,0,0,0,0
	
auto_move
	lda #KEY_RUN_STOP & 255
	sta $FD30
	sta $FF08
	lda $FF08
	and #KEY_RUN_STOP >> 8
	beq am0
	;
	lda #KEY_ESC & 255
	sta $FD30
	sta $FF08
	lda $FF08
	and #KEY_ESC >> 8
	beq am0
	;
	ldx #$00
	lda #$10
	jsr auto_eval_move
	sta auto_move_values+0
	;
	ldx #$00
	lda #$20
	jsr auto_eval_move
	sta auto_move_values+1
	;
	ldx #$10
	lda #$00
	jsr auto_eval_move
	sta auto_move_values+2
	;
	ldx #$10
	lda #$20
	jsr auto_eval_move
	sta auto_move_values+3
	;
	ldx #$20
	lda #$00
	jsr auto_eval_move
	sta auto_move_values+4
	;
	ldx #$20
	lda #$10
	jsr auto_eval_move
	sta auto_move_values+5
	;
	lda #$2F			; "drop" value
	sta auto_move_values+6
	;
	ldx #$06
	lda #$00
am2	cmp auto_move_values,x
	bcs am3
	lda auto_move_values,x
	stx selected_move+1
am3	dex
	bpl am2
	;
selected_move
	ldx #$00
	lda all_moves_lo,x
	sta move_jump+1
	lda all_moves_hi,x
	sta move_jump+2
	;
	jsr wait_a_bit
	;
move_jump
	jmp move_jump
	
am0	jmp game_over
	
auto_eval_move
	stx curr_source
	sta curr_target
	;
	lda board+$6,x			; check if there's even anything at the bottom of this source stack
	bne stack_not_empty
	;
stack_full
	lda #$00			; this move is not possible, return 0
	rts
	;
stack_not_empty
	ldx curr_source
	jsr get_top_block_value
	stx source_block_index
	sta block_in_source_stack
	;
	ldx curr_target			; get the top block from the target stack
	jsr get_top_block_value
	txa				; check its index:
	and #$0F
	cmp #$02			; is it 2?
	bne stack_not_full		; nope, won't be full
	;
	lda board,x			; are they different blocks?
	cmp block_in_source_stack
	bne stack_full			; yes, this would lead to game over, don't make this move
	;
	; ---
	;
stack_not_full
	lda #$00			; come up with "almost full value"
	sta almost_full_value
	;
	lda curr_source			; is the block that's about to fall in the current column?
	cmp active_column
	bne afv2
	;
	ldx source_block_index		; is the current stack almost full?
	txa
	and #$0F
	cmp #$02
	bne afv2
	;
	lda board,x			; will it _not_ merge and lead to game over?
	ldx active_column
	cmp board,x
	beq afv2
	;
	lda #$50			; moving a block away from here is important
	sta almost_full_value
	;
	; ---
	;
afv2	lda #$00			; come up with "untangle value"
	sta untangle_value
	;
	lda source_block_index
	and #$0F
	cmp #$06
	beq no_untangle
	;
	ldx source_block_index
	inx
	lda board,x
	cmp block_in_source_stack
	bcs no_untangle
	;
	lda #$0C
	sta untangle_value
	;
no_untangle
	lda block_in_source_stack
	ldx curr_source
	cmp board,x
	bcs no_drop_untangle
	;
	ldx curr_target
	cmp board,x
	bcc no_drop_untangle
	;
	lda untangle_value
	clc
	adc #$0C
	sta untangle_value 
	;
no_drop_untangle	
	ldx curr_target
	jsr get_top_block_value
	beq target_col_empty
	;
	cmp block_in_source_stack
	beq auto_will_merge
	;
	bcc auto_wrong_order
	;
target_col_empty
	txa
	and #$0F
	pha
	;
	ldx curr_target
	lda board,x
	cmp block_in_source_stack
	beq will_drop_merge
	;
	pla
	clc
	adc #$20
	adc untangle_value
	adc almost_full_value
	rts
	;
will_drop_merge
	lda curr_target
	cmp active_column
	beq will_drop_merge_now
	;
	pla
	clc
	adc #$28
	adc untangle_value
	adc almost_full_value
	rts
	;	
will_drop_merge_now
	pla
	clc
	adc #$30
	adc untangle_value
	adc almost_full_value
	rts
	;
auto_wrong_order
	txa				; this move would place a larger block on a smaller one
	and #$0F
	clc
	adc #$10
	adc untangle_value
	adc almost_full_value
	rts
	;
auto_will_merge
	txa
	and #$0F
	cmp #$06
	beq bottom1
	;
	lda board,x
	inx
	clc
	adc #$01
	cmp board,x
	bne bottom1
	;     
	txa
	and #$0F
	clc
	adc #$60
	adc untangle_value
	adc almost_full_value
	rts

bottom1	
	txa
	and #$0F
	clc
	adc #$40			; good move, will merge a block
	adc untangle_value
	adc almost_full_value
	;
	pha
	;
	ldx curr_target			; check if the falling block will also merge
	jsr get_top_block_value
	clc
	adc #$01
	ldx curr_target
	cmp board,x
	beq auto_will_merge_twice
	;
	pla
	rts
	;
auto_will_merge_twice
	pla
	;
	clc
	adc #$20
	rts

almost_full_value
	db 0
untangle_value
	db 0
source_block_index
	db 0	
block_in_source_stack
	db 0

get_top_block_value
	inx
gtbv1	inx
	txa
	and #$0F
	cmp #7
	beq gtbv2
	lda board,x
	beq gtbv1
	rts	
gtbv2	lda #$00
	rts

all_moves_lo
	db move12 & 255
	db move13 & 255
	db move21 & 255
	db move23 & 255
	db move31 & 255
	db move32 & 255
	db drop_active & 255
	
all_moves_hi
	db move12 >> 8
	db move13 >> 8
	db move21 >> 8
	db move23 >> 8
	db move31 >> 8
	db move32 >> 8
	db drop_active >> 8
	
move12
	ldx #$00
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_2
	
move13
	ldx #$00
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_3
	
move21
	ldx #$10
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_1
	
move23
	ldx #$10
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_3
	
move31
	ldx #$20
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_1
	
move32
	ldx #$20
	stx curr_source
	jsr draw_source_selection
	jsr wait_a_bit
	jmp press_2
	
appear_anim
	lda #$04			; x = board index
	sta menu_animation_index
	;
aa2	jsr sync
	;
	ldx active_column
      	jsr get_block_screen_addr
      	;
      	lda menu_animation_index
      	jsr ptrs_add_a
      	;
      	lda #$09
      	sec
      	sbc menu_animation_index
      	sbc menu_animation_index
      	sta aa_w+1
      	;
	lda board,x			; get the blocks's color
	tay
	lda block_colors,y
	sta curr_color
	;
	jsr get_number_char_addr	; get the graphics data's address
	;
	lda menu_animation_index
	jsr src_add_a
	;
	ldx #$02
aa1	ldy #$00
	cpx #$02
	beq aa3
	lda shadow_chars+1
	bne aa4
aa3	lda shadow_chars
aa4	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	lda #1
	jsr ptrs_add_a
	;
aa0	lda (chr_src),y
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
aa_w	cpy #$01
	bne aa0
	;
	lda #39
	jsr ptrs_add_a
	;
	lda #18
	jsr src_add_a
	;
	dex
	bpl aa1
	;
	ldy #$00
	lda shadow_chars+2
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
aa5	iny
	cpy aa_w+1
	beq aa6
	;
	lda shadow_chars+3
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	bne aa5
	;
aa6	lda shadow_chars+4
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	dec menu_animation_index
	bmi aa7
	jmp aa2
	;
aa7	rts
;	;
;aa0	jsr appear_anim_1frame
;	;
;	cpx #3*9*4
;	bne aa0
;	;      
;	; ---
;	;
;	ldy active_column
;	lda board,y
;	tay
;	lda block_colors,y
;	;
;	ldy #0
;aa4	sta (col_dst),y
;	iny
;	cpy #9
;	bne aa4
;	;
;	ldy #40
;aa5	sta (col_dst),y
;	iny
;	cpy #49
;	bne aa5
;	;
;	ldy #80
;aa6	sta (col_dst),y
;	iny
;	cpy #89
;	bne aa6
;	;
;	jsr appear_anim_1frame
;	;
;	ldy active_column
;	lda board,y			; print numbers (2 middle digits only)
;	tay
;	lda chars_0,y
;	ldy #43
;	sta (chr_dst),y
;	;
;	ldy active_column
;	lda board,y
;	tay
;	lda chars_1,y
;	ldy #44
;	sta (chr_dst),y
;	;
;	jsr appear_anim_1frame
;	jsr appear_anim_1frame
;	jsr appear_anim_1frame
;	;
;	rts
;	
;appear_anim_1frame
;	jsr sync
;	ldy #0
;aa1	lda appear_data,x
;	sta (chr_dst),y
;	inx
;	iny
;	cpy #9
;	bne aa1
;	;
;	ldy #40
;aa2	lda appear_data,x
;	beq aa21
;	sta (chr_dst),y
;aa21	inx
;	iny
;	cpy #49
;	bne aa2
;	;
;	ldy #80
;aa3	lda appear_data,x
;	sta (chr_dst),y
;	inx
;	iny
;	cpy #89
;	bne aa3
;	rts

twinkle_anim
	jsr get_block_screen_addr
      	;
	ldy #$00
	;
ta0	jsr sync
	tya
	beq ta1
	;
	lda (col_dst),y
	sec
	sbc #$10
	sta (col_dst),y
	jsr ptrs_add_40
	lda (col_dst),y
	sec
	sbc #$10
	sta (col_dst),y
	jsr ptrs_add_40
	lda (col_dst),y
	sec
	sbc #$10
	sta (col_dst),y
	jsr ptrs_sub_40
	jsr ptrs_sub_40
	;
ta1	iny
	cpy #10
	beq ta3
	;
	lda (col_dst),y
	clc
	adc #$10
	sta (col_dst),y
	jsr ptrs_add_40
	lda (col_dst),y
	clc
	adc #$10
	sta (col_dst),y
	jsr ptrs_add_40
	lda (col_dst),y
	clc
	adc #$10
	sta (col_dst),y
	jsr ptrs_sub_40
	jsr ptrs_sub_40
	;
	jmp ta0
	;
ta3	rts
	
	;
	; X = column ($00,$10,$20)
	;
drop
	ldy #$FF			; set flag for the first position (don't erase line above)
	sty first_line
	;
	iny
	sty merged			; clear flag for merged
	sty note_index			; clear note index (sound)
	;
drop_loop
	lda board+1,x			; if there's room (=0) below...
	beq move_down			; then move this piece down
	;
	cmp board,x			; if the piece below is exactly the same as this one...
	beq add_down			; then "add" (merge) it down
	;
	jmp bottom
	;
move_down
	jsr animate_block_down
	;
	lda board,x
	sta board+1,x
	;
	jmp md1
	;
add_down
	dec merged			; flag that merge occurred
	;
	lda sound_enabled
	bne ad1
	;
	ldy board+1,x			; play sound
	dey
	lda freq_lo,y
	sta $FF0F
	lda freq_hi,y
	sta $FF10
	lda #$25
	sta $FF11
	;
ad1	jsr animate_block_down
	;
	inc note_index			; go to next note
	;
	lda board+1,x
	cmp #MAX_BLOCK			; was the highest possible block reached?
	beq md2
	inc board+1,x			; no, keep going!
	;
	; --- add score
	;
md2	stx sx1+1			; save x
	;
	lda game_mode			; in tutorial mode, skip scoring
	cmp #$02
	beq sx1
	;	
	lda board+1,x
	asl a
	asl a
	asl a
	clc
	adc #$07
	tay
	ldx #hs_scorelen-1
as1	lda Score,x
	clc
	adc block_score,y
	cmp #$0A
	bcc as4				; no digit overflow
	;
	cpx #$00
	bne as2
	;
	jsr score_at_max		; score is at max, stop here
	jmp as3
	;
as2	sec
	sbc #$0A
	inc Score-1,x
as4	sta Score,x
	dey
	dex
	bpl as1
as3	jsr display_score
	;
	; ---
	;
sx1	ldx #$00			; restore saved x
	;
md1	lda #$00
	sta board,x			; clearn this piece from the board
	inx				; go down
	txa
	and #$0F
	cmp #$06			; check if we're at the bottom (size of stack)
	beq bottom
	;
	jmp drop_loop
	;
	; --- fallen to the bottom
	;
bottom	jsr sync
	jsr draw_block			; draw block at it's "final" place
	;
	lda first_line
	bne bt1
	;              
	jsr get_block_screen_addr
	jsr ptrs_sub_40
	jsr erase_top_line		; and erase the line above
	;
bt1	lda #$00
	sta first_line
	;
	lda #$00
	sta $FF11
	;
	lda merged
	beq no_twinkle
	;
	lda animation_enabled		; skip if animations are disabled
	bmi no_twinkle
	;
	jsr twinkle_anim
	;
no_twinkle
	rts

	;
	;
	;
score_at_max
	lda #$09
	db $2C
clear_score
	lda #$00
	ldx #hs_scorelen-1
cs1	sta Score,x
	dex
	bpl cs1
	rts
	
display_score
	ldx #hs_scorelen-1
ds1	lda Score,x
	clc
	adc zero_index			; convert to numeric characters
	sta score_screen_addr,x
	dex
	bne ds1				; skip first zero...
	rts

animate_block_down	
	lda animation_enabled
	bmi abd1
	;
	jsr sync			; <<< animation start
	;
abd1	jsr vol_down
	jsr draw_block			; step 1
	;
	lda first_line			; flag for "don't erase the line before"
	bne abd2
	;
	jsr get_block_screen_addr
	jsr ptrs_sub_40
	jsr erase_top_line

abd2	lda animation_enabled
	bmi abd3
	;
	jsr sync
	;
abd3	jsr vol_down
	jsr get_block_screen_addr
	jsr erase_top_line
	jsr get_block_screen_addr
	jsr ptrs_add_40
	jsr draw_block_addr		; step 2
	;
	jsr sync
	jsr vol_down
	jsr get_block_screen_addr
	jsr ptrs_add_40
	jsr erase_top_line
	jsr get_block_screen_addr
	jsr ptrs_add_40
	jsr ptrs_add_40
	jsr draw_block_addr		; step 3 >>> animation end
	;
	lda #$00
	sta first_line			; clear flag
	;
	rts
	
vol_down
	lda $FF11			; decrement volume (if sound is playing)
	beq vd1
	;
	dec $FF11
vd1	rts
	
	;
	; X = column ($00,$10,$20)
	;
generate_top_block
	stx gtb1+1
	jsr get_highest_block
	clc
	adc #$02
	lsr a
	jsr get_rand_max
gtb1	ldx #$00
	sta board,x
	rts

	;
	; Find the currently highest block on the board
	;	
get_highest_block
	ldx #$00
	lda board
ghb2	cmp board,x
	bcs ghb1
	;
	lda board,x
ghb1	inx
	cpx #$30
	bne ghb2
	rts
	
	;
	; Generate a number between 1-A
	;
get_rand_max
	sta gry3+1
	tax
	lda max_and,x
	sta gry2+1
gry1	jsr GetRandom
gry2	and #$00
gry3	cmp #$00
	bcs gry1
	clc
	adc #$01
	rts
	
	;
	; initializes the board to start a new game
	;   
init_board
	ldx #$2F			; clear completely
	lda #$00
ib1	sta board,x
	dex
	bpl ib1
	;
ib2	ldy #$08			; initialize 9 positions
ib3	lda init_board_1,y
	jsr get_rand_max
	ldx init_board_2,y
	sta board,x
	dey
	bpl ib3
	;
	lda board+$05			; make sure there are no duplicates
	cmp board+$06
	beq ib2				; if two block on top of each other are the same, try again
	lda board+$15
	cmp board+$16
	beq ib2
	lda board+$25
	cmp board+$26
	beq ib2
	;
	rts
	
wait_a_bit
	ldx #25
	lda $FF07
	and #$40
	beq *+4
	ldx #30
wab1	jsr sync
	;
	lda #KEY_RUN_STOP & 255
	sta $FD30
	sta $FF08
	lda $FF08
	and #KEY_RUN_STOP >> 8
	beq wab_x
	;
	lda #KEY_ESC & 255
	sta $FD30
	sta $FF08
	lda $FF08
	and #KEY_ESC >> 8
	beq wab_x
	;
	dex
	bpl wab1
	rts

wab_x	jmp game_over

sync_bottom
	lda $FF07
	and #$40
	beq sb1
	lda #$F8			; sync NTSC value
	db $2C
sb1	lda #$FF			; sync PAL value
	db $2C
sync
	lda #$BC			; sync to frame bottom
	cmp $FF1D
	bne *-3
	rts
	
draw_full_board
	jsr init_graphics
	;
	jsr clear_screen
	;
	lda graphics_mode
	beq dfb1
	;
	lda #$2C
	sta fill_area+1
	lda #$0C
	sta fill_area+3
	lda #22
	sta fa_h+1
	lda #30
	sta fa_w+1	
	;
	lda #$71
	sta fa_color+1
	;
	jsr fill_area
	;
dfb1	jsr draw_column_1
	jsr draw_column_2
	;	
draw_column_3
	ldx #$26
	db $2C
draw_column_2
	ldx #$16
	db $2C
draw_column_1
	ldx #$06
	;
draw_column_x
dc1	txa
	pha
	;
	jsr draw_block
	;
	pla
	tax
	dex
	and #$0F
	cmp #$02			; skip board position 1
	bne dc2
	;
	dex
	;
dc2	cmp #$00
	bne dc1
	rts

draw_source_selection
	ldx curr_source
	inx
dss1	inx				; find the topmost block
	lda board,x			; keep going while 0
	beq dss1
	;
	; X = block index
	;
draw_selected_block
	lda #$09
	sta draw_selected
	;
	jsr draw_block
	;
	lda #$00
	sta draw_selected
	;
	rts
	
clear_source_selection
	ldx curr_source
	inx
css1	inx				; find the topmost block
	lda board,x			; keep going while 0
	beq css1			; afterwards, continue to "draw_block" and return
	;
	; X = block to draw (index)
	;
draw_block
	jsr get_block_screen_addr
	;
draw_block_addr
	lda board,x			; get the blocks's color
	tay
draw_block_y
	lda block_colors,y
	sta curr_color
	;
	jsr get_number_char_addr	; get the graphics data's address
	;
	; ---
	;
	jsr ptrs_sub_40			; check for exception...
	ldy #$00
	lda (chr_dst),y
	tay
	jsr ptrs_add_40
	;
	cpy shadow_chars+1		; if there's alread a "side shadow" on the character above, also draw a side
	beq db_c
	;
	lda chr_dst+1			; < $D68
	cmp #$0D
	bcc db_b
	bne db_c
	lda chr_dst
	cmp #$68
	bcs db_c
	;
db_b	lda shadow_chars		; --- shadow (corner)
	bne *+5
db_c	lda shadow_chars+1		; shadow (side)
	ldy #$00
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	lda #$01
	jsr ptrs_add_a
	;
	ldy #8				; top
db1	lda (chr_src),y
	sta (chr_dst),y
	lda curr_color			; color
	sta (col_dst),y
	dey
	bpl db1
	;
	lda #39
	jsr ptrs_add_a
	;
	lda #18
	jsr src_add_a
	;
	ldy #$00			; --- shadow (side)
	lda shadow_chars+1
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	lda #$01
	jsr ptrs_add_a
	;
	ldy #8				; middle
db2	lda (chr_src),y
	sta (chr_dst),y
	lda curr_color			; color
	sta (col_dst),y
	dey
	bpl db2
	;
	lda #39
	jsr ptrs_add_a
	;
	lda #18
	jsr src_add_a
	;
	ldy #$00			; --- shadow (side)
	lda shadow_chars+1
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	lda #$01
	jsr ptrs_add_a
	;
	ldy #8				; bottom
db3	lda (chr_src),y
	sta (chr_dst),y
	lda curr_color			; color
	sta (col_dst),y
	dey
	bpl db3
	;
	lda #39
	jsr ptrs_add_a
	;
	; ---				; --- bottom shadow
	;
	ldy #$00			; exception: "merge" left side shadow
	lda (chr_dst),y			; at the top of the stacks
	cmp shadow_chars
	bne db_x
	;
	lda shadow_chars+1
	sta (chr_dst),y
	;
db_x	lda chr_dst			; > $F98 = draw
	cmp #$98
	bcc db_d1
	lda chr_dst+1
	cmp #$0F
	beq db_d
	;
db_d1	lda chr_dst+1			; < $D40 = draw
	cmp #$0D
	bcc db_d
	bne db_e
	lda chr_dst
	cmp #$40
	bcs db_e
	;
db_d	ldy #$00			; draw bottom shadow
	lda shadow_chars+2
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
	lda #1
	jsr ptrs_add_a
	;
	ldy #8
db4	lda shadow_chars+3
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	dey
	bpl db4
	;
	lda #8
	jsr ptrs_add_a
	;
	ldy #$00
	lda shadow_chars+4
	sta (chr_dst),y
	lda shadow_color
	sta (col_dst),y
	;
db_e	rts

get_number_char_addr
ncl	lda number_chars_lo,y
	clc
	adc draw_selected
	sta chr_src
nch	lda number_chars_hi,y
	adc #$00
	sta chr_src+1
	rts
	
	;
	; X = block index
	;     col_dst, chr_dst = screen address
	;
get_block_screen_addr
	lda block_screen_addr_lo,x
	sta chr_dst
	sta col_dst
	lda block_screen_addr_hi,x
	bne sp1
	;	
set_dst	stx chr_dst
	stx col_dst
	;
sp1	sta chr_dst+1
	and #$FB
	sta col_dst+1
	rts
	
ptrs_add_40
	lda #40
ptrs_add_a
	clc
	adc chr_dst
	sta chr_dst
	sta col_dst
	bcc *+6
	inc chr_dst+1
	inc col_dst+1
	;
	rts
	
ptrs_sub_40
	lda chr_dst
	sec
	sbc #40
	sta chr_dst
	sta col_dst
	bcs *+6
	dec chr_dst+1
	dec col_dst+1
	;
	rts

src_add_a	
	clc
	adc chr_src
	sta chr_src
	bcc *+4
	inc chr_src+1
	rts
	
erase_top_line
	lda chr_dst+1			; < $D40?
	cmp #$0D
	bcc etl_1
	bne etl_2
	lda chr_dst
	cmp #$40
	bcs etl_2
	;
etl_1	jsr ptrs_sub_40			; check for exception...
	ldy #$00
	lda (chr_dst),y
	tay
	jsr ptrs_add_40
	;
	cpy shadow_chars+1		; is there a block in the line above?
	bne etl_4
	;
	jmp db_d			; draw bottom shadow instead of erase (for the block that's in the top line)
	;
etl_4	lda top_background_color
	ldy #$00
	beq etl_3			; always jump
	;
etl_2	lda stack_background_color
	ldy #$01			; start from position 1 (skip position 0, which is the left shadow)
	;
etl_3	sta curr_color
	;
etl_l1	lda stack_background_char	; space char
	sta (chr_dst),y
	lda curr_color
	sta (col_dst),y
	iny
	cpy #10
	bne etl_l1
	rts
	
	;
	; ---
	;	
irq	pha
	txa
	pha
	asl $FF09
	;
	ldx #$07
inc2	dex
	bmi inc1			; just in case
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$00
inc3	sta time,x
	beq inc2
inc1	;
message_delay
	ldx #$00
	beq iq1
	dex
	stx message_delay+1
	bne iq1
	;
	jsr clear_status_line
	;
iq1	pla
	tax
	pla
	rti
	
clear_status_line
	ldx #$27
iq2	lda space_char
	sta $0FC0,x
	dex
	bpl iq2
	rts
	
menu_key_table
	dw menu_animation
	;
	dw KEY_ESC, quit
	dw KEY_RUN_STOP, quit
	dw KEY_SPACE, start_game
	dw KEY_RETURN, start_game
	dw KEY_D, start_demo
	dw KEY_T, start_tutorial
	dw KEY_HELP, start_tutorial
	dw 0
	
tutorial_key_table
	dw tutorial_loop
	;
	dw KEY_ESC, title_screen
	dw KEY_RUN_STOP, title_screen
	dw KEY_CURSOR_DOWN, tutorial_next_page
	dw KEY_CURSOR_RIGHT, tutorial_next_page
	dw KEY_SPACE, tutorial_next_page
	dw KEY_RETURN, tutorial_next_page
	dw 0

game_key_table
	dw null
	;
	dw KEY_1, press_1
	dw KEY_2, press_2
	dw KEY_3, press_3
	;
	dw KEY_D, drop_active
	;
	dw KEY_S, toggle_sound
	dw KEY_A, toggle_animation
	dw KEY_G, toggle_graphics
	;
	dw KEY_ESC, deselect
	dw KEY_RUN_STOP, game_over
	;
	dw 0
	
null
	;inc $FF19
	rts
	
	include "key_constants.asm"
	include "keyboard.asm"
	include "random.asm"
	
time
	db 0,0, 0,0, 0,0, 0
	
time_end
	db $A,$A, $6,$A, $6,$A, 50
	
freq_lo
	db $A9,$59,$C5,$54,$AD
	db $E3,$2A,$56,$71,$95
	db $AB,$B9,$CB,$D6,$DC
	db $DC
	
freq_hi
	db $00,$01,$01,$02,$02
	db $02,$03,$03,$03,$03
	db $03,$03,$03,$03,$03
	db $03
	
;appear_data
;	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
;	db $A0,$A0,$A0,$20,$20,$20,$A0,$A0,$A0
;	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
;	
;	db $A0,$A0,$EF,$EF,$EF,$EF,$EF,$A0,$A0
;	db $A0,$A0,$20,$20,$20,$20,$20,$A0,$A0
;	db $A0,$A0,$F7,$F7,$F7,$F7,$F7,$A0,$A0
;	
;	db $A0,$78,$78,$78,$78,$78,$78,$78,$A0
;	db $A0,$20,$20,$20,$20,$20,$20,$20,$A0
;	db $A0,$79,$79,$79,$79,$79,$79,$79,$A0
;	
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20
;	
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20
;	db $20,$20,$20,$00,$00,$A0,$20,$20,$20
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20
;	
;	db $20,$20,$6F,$6F,$6F,$6F,$6F,$20,$20
;	db $20,$20,$A0,$00,$00,$A0,$A0,$20,$20
;	db $20,$20,$77,$77,$77,$77,$77,$20,$20
;	
;	db $20,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$20
;	db $20,$A0,$A0,$00,$00,$A0,$A0,$A0,$20
;	db $20,$F9,$F9,$F9,$F9,$F9,$F9,$F9,$20
;	
;	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
;	db $A0,$A0,$A0,$00,$00,$A0,$A0,$A0,$A0
;	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	
;twinkle_data
;	db $00,$00,$00,$00,$00,$00,$00,$00,$00 ; $5F/$DF
;	db $00,$00,$00,$00,$00,$00,$00,$00,$00
;	db $5F,$00,$00,$00,$00,$00,$00,$00,$00
;	
;	db $00,$00,$00,$00,$00,$00,$00,$00,$00
;	db $5F,$00,$00,$00,$00,$00,$00,$00,$00
;	db $DF,$5F,$00,$00,$00,$00,$00,$00,$00
;	
;	db $20,$5F,$00,$00,$00,$00,$00,$00,$00
;	db $DF,$20,$5F,$00,$00,$00,$00,$00,$00
;	db $A0,$DF,$20,$5F,$00,$00,$00,$00,$00
;	
;	db $A0,$DF,$FF,$FF,$5F,$A0,$A0,$A0,$A0
;	db $A0,$A0,$DF,$FF,$FF,$5F,$A0,$A0,$A0
;	db $00,$A0,$A0,$DF,$FF,$FF,$5F,$A0,$A0
;	
;	db $00,$A0,$FF,$FF,$DF,$20,$20,$5F,$00
;	db $00,$00,$A0,$FF,$FF,$DF,$20,$20,$5F
;	db $00,$00,$00,$A0,$FF,$FF,$DF,$20,$20
;	
;	db $00,$00,$00,$00,$A0,$A0,$A0,$DF,$5F
;	db $00,$00,$00,$00,$00,$A0,$A0,$A0,$DF
;	db $00,$00,$00,$A0,$00,$00,$A0,$A0,$A0
;	
;	db $00,$00,$00,$00,$00,$00,$00,$A0,$DF
;	db $00,$00,$00,$00,$00,$00,$00,$00,$A0
;	db $00,$00,$00,$A0,$00,$00,$00,$00,$00
;	
;	db $00,$00,$00,$00,$00,$00,$00,$00,$A0
;	db $00,$00,$00,$00,$00,$00,$00,$00,$00
;	db $00,$00,$00,$A0,$00,$00,$00,$00,$00
	
init_board_1
	db 2,2,2, 3,3,3, 3,3,3
init_board_2
	db $00,$10,$20, $05,$15,$25, $06,$16,$26 
	
	;
	; Used for generating random numbers
	; How many bits to keep max.
	;
max_and
	db 0
	db 1, 3,3, 7,7,7,7
	db 15,15,15,15,15,15,15,15
	db 31

	;
	; Colors for the blocks
	;
block_colors
	db EMPTY_COLOR
	db $61,$64,$52,$42,$57
	db $67,$55,$45,$43,$36
	db $16,$34,$24,$14,$04
	db $00
	
;chars_0
;	db $66
;	db " "+$80," "+$80," "+$80," "+$80," "+$80," "+$80," "+$80," "+$80," "+$80
;	db "1"+$80,"1"+$80,"1"+$80,"1"+$80,"1"+$80,"1"+$80,"1"+$80
;	
;chars_1
;	db $66
;	db "1"+$80,"2"+$80,"3"+$80,"4"+$80,"5"+$80,"6"+$80,"7"+$80,"8"+$80,"9"+$80
;	db "0"+$80,"1"+$80,"2"+$80,"3"+$80,"4"+$80,"5"+$80,"6"+$80

	;
	; values of each block (when merged)
	;	
block_score
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,4 ; piece 2
	db 0,0,0,0,0,0,0,8 ; piece 3
	db 0,0,0,0,0,0,1,6 ; piece 4
	db 0,0,0,0,0,0,3,2 ; piece 5
	db 0,0,0,0,0,0,6,4 ; piece 6
	db 0,0,0,0,0,1,2,8 ; piece 7
	db 0,0,0,0,0,2,5,6 ; piece 8
	db 0,0,0,0,0,5,1,2 ; piece 9
	db 0,0,0,0,1,0,2,4 ; piece 10
	db 0,0,0,0,2,0,4,8 ; piece 11
	db 0,0,0,0,4,0,9,6 ; piece 12
	db 0,0,0,0,8,1,9,2 ; piece 13 
	db 0,0,0,1,6,3,8,4 ; piece 14
	db 0,0,0,3,2,7,6,8 ; piece 15
	db 0,0,0,6,5,5,3,6 ; piece 16
	
block_screen_addr_lo
	db ($0C00+4+10*0+(2+0*3)*40) & 255
	db ($0C00+4+10*0+(2+1*3)*40) & 255
	db ($0C00+4+10*0+(2+2*3)*40) & 255
	db ($0C00+4+10*0+(2+3*3)*40) & 255
	db ($0C00+4+10*0+(2+4*3)*40) & 255
	db ($0C00+4+10*0+(2+5*3)*40) & 255
	db ($0C00+4+10*0+(2+6*3)*40) & 255
	db 0, 0,0,0,0, 0,0,0,0
	
	db ($0C00+4+10*1+(2+0*3)*40) & 255
	db ($0C00+4+10*1+(2+1*3)*40) & 255
	db ($0C00+4+10*1+(2+2*3)*40) & 255
	db ($0C00+4+10*1+(2+3*3)*40) & 255
	db ($0C00+4+10*1+(2+4*3)*40) & 255
	db ($0C00+4+10*1+(2+5*3)*40) & 255
	db ($0C00+4+10*1+(2+6*3)*40) & 255
	db 0, 0,0,0,0, 0,0,0,0
	
	db ($0C00+4+10*2+(2+0*3)*40) & 255
	db ($0C00+4+10*2+(2+1*3)*40) & 255
	db ($0C00+4+10*2+(2+2*3)*40) & 255
	db ($0C00+4+10*2+(2+3*3)*40) & 255
	db ($0C00+4+10*2+(2+4*3)*40) & 255
	db ($0C00+4+10*2+(2+5*3)*40) & 255
	db ($0C00+4+10*2+(2+6*3)*40) & 255
	db 0, 0,0,0,0, 0,0,0,0
	
block_screen_addr_hi
	db ($0C00+4+10*0+(2+0*3)*40) >> 8
	db ($0C00+4+10*0+(2+1*3)*40) >> 8
	db ($0C00+4+10*0+(2+2*3)*40) >> 8
	db ($0C00+4+10*0+(2+3*3)*40) >> 8
	db ($0C00+4+10*0+(2+4*3)*40) >> 8
	db ($0C00+4+10*0+(2+5*3)*40) >> 8
	db ($0C00+4+10*0+(2+6*3)*40) >> 8
	db 0, 0,0,0,0, 0,0,0,0
	
	db ($0C00+4+10*1+(2+0*3)*40) >> 8
	db ($0C00+4+10*1+(2+1*3)*40) >> 8
	db ($0C00+4+10*1+(2+2*3)*40) >> 8
	db ($0C00+4+10*1+(2+3*3)*40) >> 8
	db ($0C00+4+10*1+(2+4*3)*40) >> 8
	db ($0C00+4+10*1+(2+5*3)*40) >> 8
	db ($0C00+4+10*1+(2+6*3)*40) >> 8
	db 0, 0,0,0,0, 0,0,0,0
	
	db ($0C00+4+10*2+(2+0*3)*40) >> 8
	db ($0C00+4+10*2+(2+1*3)*40) >> 8
	db ($0C00+4+10*2+(2+2*3)*40) >> 8
	db ($0C00+4+10*2+(2+3*3)*40) >> 8
	db ($0C00+4+10*2+(2+4*3)*40) >> 8
	db ($0C00+4+10*2+(2+5*3)*40) >> 8
	db ($0C00+4+10*2+(2+6*3)*40) >> 8
	db 0, 0,0,0,0, 0,0,0,0
	
Score
	db 0,0,0,0,0,0,0,0
	db 0
	
HighScore
	db 0,0,0,0,0,0,0,0
	
;logos
;	db $74,$20,$74,$4F,$74,$4F,$74,$4F,$74,$6A,$6A,$50,$6A,$50
;	db $74,$20,$74,$74,$74,$4C,$74,$74,$20,$6A,$20,$6A,$20,$6A
;	db $74,$20,$74,$74,$74,$74,$20,$77,$74,$6A,$6A,$77,$20,$50
;	db $4C,$74,$74,$74,$74,$4C,$74,$4C,$74,$6A,$6A,$7A,$6A,$7A
;	db $61,$20,$61,$EC,$61,$EC,$61,$EC,$61,$E1,$E1,$FB,$E1,$FB
;	db $61,$20,$61,$61,$61,$61,$61,$61,$20,$E1,$20,$E1,$20,$E1
;	db $61,$20,$61,$61,$61,$EC,$7E,$E2,$61,$E1,$E1,$E2,$20,$FB
;	db $FC,$61,$61,$61,$61,$FC,$61,$FC,$61,$E1,$E1,$FE,$E1,$FE
	
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	;cmap "!",27
	;cmap ",",28
	;cmap "-",29
	;cmap ".",30
	;cmap "0",31,32,33,34,35,36,37,38,39,40
	;cmap ":",41
game_over_text
	db "GAME OVER"
play_time
	db "PLAY TIME:"
final_score
	db "FINAL SCORE:"
congrats1
	db "CONGRATULATIONS"
congrats2
	db "NEW HIGH SCORE!"
demo
	db "DEMO"
press_space
	db "PRESS SPACE TO CONTINUE"
	
sound_text
	db "SOUND "
animation_text
	db "ANIMATION "
on_off_text
	db "ON OFF"
graphics_text
	db "GRAPHICS: "
graphics_custom
	db "CUSTOM "
graphics_petscii
	db "PETSCII"

tutorial_page_1
	;   1234567890123
	db 11,8
	db "WELCOME TO "
	db "STACK 123! "
	db "           "
	db "YOU PLAY   "
	db "BY MOVING  "
	db "BLOCKS FROM"
	db "ONE STACK  "
	db "TO ANOTHER."
	
tutorial_page_2  
	db 12,8
	db "HERE IS AN  "
	db "EXAMPLE:    "
	db "            "
	db "WE WILL MOVE"
	db "THE 2 BLOCK "
	db "FROM THE 3RD"
	db "STACK TO THE"
	db "SECOND.     "
  
tutorial_page_3	
	db 10,9
	db "TO MOVE A "
	db "BLOCK, WE "
	db "PRESS 1-3 "
	db "TO SELECT "
	db "ITS STACK."
	db "          "
	db "PRESSING 3"
	db "SELECTS   "
	db "OUR BLOCK."
	
tutorial_page_4	
	db 11,9
	db "WE THEN    "
	db "PRESS 1-3  "
	db "TO SELECT  "
	db "THE TARGET."
	db "           "
	db "PRESSING 2 "
	db "COMPLETED  "
	db "OUR FIRST  "
	db "MOVE.      "
	
tutorial_page_5
 	db 9,5
	db "ONLY THE "
	db "TOP BLOCK"
	db "IN EACH  "
	db "STACK CAN"
	db "BE MOVED."
	
tutorial_page_6
	db 11, 9
	db "IF YOU     "
	db "SELECT A   "
	db "BLOCK BY   "
	db "MISTAKE OR "
	db "CHANGE YOUR"
	db "MIND, PRESS"
	db "ESC TO     "
	db "CLEAR THE  "
	db "SELECTION. "
	
tutorial_page_7	
	db 11,7
	db "AFTER EACH "
	db "MOVE THE   "
	db "HIGHLIGHTED"
	db "BLOCK      "
	db "FROM THE   "
	db "TOP LINE   "
	db "WILL DROP. "

tutorial_page_8	
	db 11,8
	db "WHEN THERE "
	db "ARE NO GOOD"
	db "MOVES,     "
	db "YOU CAN    "
	db "SKIP MOVING"
	db "ANY BLOCKS "
	db "BY PRESSING"
	db "D.         "

tutorial_page_9	
	db 11,9
	db "BLOCKS WITH"
	db "THE SAME   "
	db "NUMBERS    "
	db "MERGE.     "
	db "           "
	db "THIS SCORES"
	db "POINTS AND "
	db "FREES UP   "
	db "SPACE.     "

tutorial_page_10
	db 10,7
	db "THE GAME  "
	db "IS OVER   "
	db "WHEN A    "
	db "STACK     "
	db "FILLS UP. "
	db "          "
	db "GOOD LUCK!"
	
title_text
	db "  BY CSABO IN 2020  ",0
	db "HIGH SCORE: "
hs_dest
	db "        ",0
title_1
	db "PRESS T FOR TUTORIAL",0
	db "PRESS SPACE TO START",0
title_2
	db " PRESS D FOR A DEMO ",0
	cmap
	
tutorial_pages_lo
	db tutorial_page_1 & 255
	db tutorial_page_2 & 255
	db tutorial_page_3 & 255
	db tutorial_page_4 & 255
	db tutorial_page_5 & 255
	db tutorial_page_6 & 255
	db tutorial_page_7 & 255
	db tutorial_page_8 & 255
	db tutorial_page_9 & 255
	db tutorial_page_10 & 255
	
tutorial_pages_hi
	db tutorial_page_1 >> 8
	db tutorial_page_2 >> 8
	db tutorial_page_3 >> 8
	db tutorial_page_4 >> 8
	db tutorial_page_5 >> 8
	db tutorial_page_6 >> 8
	db tutorial_page_7 >> 8
	db tutorial_page_8 >> 8
	db tutorial_page_9 >> 8
	db tutorial_page_10 >> 8
	
;board
;	db 0,0,0,0,0,0,0
;	db 0, 0,0,0,0, 0,0,0,0
;	
;	db 0,0,0,0,0,0,0
;	db 0, 0,0,0,0, 0,0,0,0
;	
;	db 0,0,0,0,0,0,0
;	db 0, 0,0,0,0, 0,0,0,0
	
	; rule: +2, LSR
	
	; [max 3]: 2
	; [max 4]: 3
	; [max 5]: 3
	; [max 6]: 4
	; [max 7]: 4
	; [max 8]: 5
	; [max 9]: 5
	; [max10]: 6
	
	include "charmap.asm"
	
	align $0800
	include "charset.asm"

petscii_charmap
	db $66,$66,$66,$66,$66,$66,$66,$66,$66,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	db $66,$66,$66,$66,$66,$66,$66,$66,$66,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	db $66,$66,$66,$66,$66,$66,$66,$66,$66,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	db $A0,$A0,$A0,$A0,$E2,$A0,$A0,$A0,$A0,$F0,$C0,$A0,$A0,$E2,$A0,$A0,$C0,$EE
	db $A0,$A0,$A0,$A0,$61,$A0,$A0,$A0,$A0,$DD,$A0,$A0,$A0,$61,$A0,$A0,$A0,$DD
	db $A0,$A0,$A0,$A0,$FC,$A0,$A0,$A0,$A0,$ED,$C0,$A0,$A0,$FC,$A0,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$EC,$C0,$FE,$A0,$A0,$A0,$DD,$A0,$A0,$EC,$C0,$FE,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$A0,$C0,$E1,$A0,$A0,$A0,$DD,$A0,$A0,$A0,$C0,$E1,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$A0,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$A0,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$FC,$C0,$E1,$A0,$A0,$A0,$DD,$A0,$A0,$FC,$C0,$E1,$A0,$A0,$DD
	db $A0,$A0,$A0,$A0,$A0,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$A0,$A0,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$FC,$C0,$FB,$A0,$A0,$A0,$DD,$A0,$A0,$FC,$C0,$FB,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$61,$C0,$FB,$A0,$A0,$A0,$DD,$A0,$A0,$61,$C0,$FB,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$A0,$A0,$E1,$A0,$A0,$A0,$DD,$A0,$A0,$A0,$A0,$E1,$A0,$A0,$DD
	db $A0,$A0,$A0,$A0,$A0,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$A0,$A0,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$61,$C0,$E1,$A0,$A0,$A0,$DD,$A0,$A0,$61,$C0,$E1,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$A0,$EC,$E2,$FB,$A0,$A0,$A0,$F0,$C0,$A0,$EC,$E2,$FB,$A0,$C0,$EE
	db $A0,$A0,$A0,$FC,$C0,$E1,$A0,$A0,$A0,$DD,$A0,$A0,$FC,$C0,$E1,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$62,$FE,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$62,$FE,$A0,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$E2,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$E2,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$61,$A0,$E1,$A0,$A0,$DD,$A0,$A0,$E1,$61,$A0,$E1,$A0,$DD
	db $A0,$A0,$A0,$FE,$FC,$62,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$FC,$62,$FE,$C0,$FD
	db $A0,$A0,$A0,$E2,$A0,$E2,$A0,$A0,$A0,$F0,$C0,$A0,$E2,$A0,$E2,$A0,$C0,$EE
	db $A0,$A0,$A0,$61,$A0,$61,$A0,$A0,$A0,$DD,$A0,$A0,$61,$A0,$61,$A0,$A0,$DD
	db $A0,$A0,$A0,$FC,$A0,$FC,$A0,$A0,$A0,$ED,$C0,$A0,$FC,$A0,$FC,$A0,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$E2,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$E2,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$EC,$C0,$FE,$A0,$A0,$DD,$A0,$A0,$E1,$EC,$C0,$FE,$A0,$DD
	db $A0,$A0,$A0,$FE,$FC,$62,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$FC,$62,$FE,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$E2,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$E2,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$A0,$C0,$E1,$A0,$A0,$DD,$A0,$A0,$E1,$A0,$C0,$E1,$A0,$DD
	db $A0,$A0,$A0,$FE,$FC,$62,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$FC,$62,$FE,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$A0,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$A0,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$FC,$C0,$E1,$A0,$A0,$DD,$A0,$A0,$E1,$FC,$C0,$E1,$A0,$DD
	db $A0,$A0,$A0,$FE,$A0,$A0,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$A0,$A0,$FE,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$E2,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$E2,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$FC,$C0,$FB,$A0,$A0,$DD,$A0,$A0,$E1,$FC,$C0,$FB,$A0,$DD
	db $A0,$A0,$A0,$FE,$FC,$62,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$FC,$62,$FE,$C0,$FD
	db $A0,$A0,$EC,$FB,$EC,$E2,$FB,$A0,$A0,$F0,$C0,$EC,$FB,$EC,$E2,$FB,$C0,$EE
	db $A0,$A0,$A0,$E1,$61,$C0,$FB,$A0,$A0,$DD,$A0,$A0,$E1,$61,$C0,$FB,$A0,$DD
	db $A0,$A0,$A0,$FE,$FC,$62,$FE,$A0,$A0,$ED,$C0,$A0,$FE,$FC,$62,$FE,$C0,$FD

number_chars_lo
	db (charmap + 0 * (6*9)) & 255
	db (charmap + 1 * (6*9)) & 255
	db (charmap + 2 * (6*9)) & 255
	db (charmap + 3 * (6*9)) & 255
	db (charmap + 4 * (6*9)) & 255
	db (charmap + 5 * (6*9)) & 255
	db (charmap + 6 * (6*9)) & 255
	db (charmap + 7 * (6*9)) & 255
	db (charmap + 8 * (6*9)) & 255
	db (charmap + 9 * (6*9)) & 255
	db (charmap + 10 * (6*9)) & 255
	db (charmap + 11 * (6*9)) & 255
	db (charmap + 12 * (6*9)) & 255
	db (charmap + 13 * (6*9)) & 255
	db (charmap + 14 * (6*9)) & 255
	db (charmap + 15 * (6*9)) & 255
	db (charmap + 16 * (6*9)) & 255
	
number_chars_hi
	db (charmap + 0 * (6*9)) >> 8
	db (charmap + 1 * (6*9)) >> 8
	db (charmap + 2 * (6*9)) >> 8
	db (charmap + 3 * (6*9)) >> 8
	db (charmap + 4 * (6*9)) >> 8
	db (charmap + 5 * (6*9)) >> 8
	db (charmap + 6 * (6*9)) >> 8
	db (charmap + 7 * (6*9)) >> 8
	db (charmap + 8 * (6*9)) >> 8
	db (charmap + 9 * (6*9)) >> 8
	db (charmap + 10 * (6*9)) >> 8
	db (charmap + 11 * (6*9)) >> 8
	db (charmap + 12 * (6*9)) >> 8
	db (charmap + 13 * (6*9)) >> 8
	db (charmap + 14 * (6*9)) >> 8
	db (charmap + 15 * (6*9)) >> 8
	db (charmap + 16 * (6*9)) >> 8
	
petscii_number_chars_lo
	db (petscii_charmap + 0 * (6*9)) & 255
	db (petscii_charmap + 1 * (6*9)) & 255
	db (petscii_charmap + 2 * (6*9)) & 255
	db (petscii_charmap + 3 * (6*9)) & 255
	db (petscii_charmap + 4 * (6*9)) & 255
	db (petscii_charmap + 5 * (6*9)) & 255
	db (petscii_charmap + 6 * (6*9)) & 255
	db (petscii_charmap + 7 * (6*9)) & 255
	db (petscii_charmap + 8 * (6*9)) & 255
	db (petscii_charmap + 9 * (6*9)) & 255
	db (petscii_charmap + 10 * (6*9)) & 255
	db (petscii_charmap + 11 * (6*9)) & 255
	db (petscii_charmap + 12 * (6*9)) & 255
	db (petscii_charmap + 13 * (6*9)) & 255
	db (petscii_charmap + 14 * (6*9)) & 255
	db (petscii_charmap + 15 * (6*9)) & 255
	db (petscii_charmap + 16 * (6*9)) & 255
	
petscii_number_chars_hi
	db (petscii_charmap + 0 * (6*9)) >> 8
	db (petscii_charmap + 1 * (6*9)) >> 8
	db (petscii_charmap + 2 * (6*9)) >> 8
	db (petscii_charmap + 3 * (6*9)) >> 8
	db (petscii_charmap + 4 * (6*9)) >> 8
	db (petscii_charmap + 5 * (6*9)) >> 8
	db (petscii_charmap + 6 * (6*9)) >> 8
	db (petscii_charmap + 7 * (6*9)) >> 8
	db (petscii_charmap + 8 * (6*9)) >> 8
	db (petscii_charmap + 9 * (6*9)) >> 8
	db (petscii_charmap + 10 * (6*9)) >> 8
	db (petscii_charmap + 11 * (6*9)) >> 8
	db (petscii_charmap + 12 * (6*9)) >> 8
	db (petscii_charmap + 13 * (6*9)) >> 8
	db (petscii_charmap + 14 * (6*9)) >> 8
	db (petscii_charmap + 15 * (6*9)) >> 8
	db (petscii_charmap + 16 * (6*9)) >> 8
	
shadow_chr = $1B;(shadow_char_gfx - charset) / 8
border_chr = $22;(border_char_gfx - charset) / 8

gfx_data
space_char
	db 0
zero_index
	db 0
invert_chars
	db 0
shadow_chars
	db 0,0,0,0,0
top_background_color
	db 0
stack_background_color
	db 0
stack_background_char
	db 0
shadow_color
	db 0
tutorial_color
	db 0
tutorial_border_color
	db 0 
border_chars
	db 0,0,0,0,0,0,0,0

gfx_custom
	db $20			; space
	
	db $30			; zero
	
	db $00			; invert chars
	
	db shadow_chr+0
	db shadow_chr+1
	db shadow_chr+2
	db shadow_chr+3
	db shadow_chr+4
	
	db BACKGROUND_COLOR+8
	db EMPTY_COLOR
	db $20			; stack background character
	
	db BACKGROUND_COLOR+8	; shadow color (same as background, but multi-color)
	
	db $13			; tutorial color
	db $13+8		; tutorial border color
	
	db border_chr+0
	db border_chr+1
	db border_chr+2
	db border_chr+3
	db border_chr+4
	db border_chr+5
	db border_chr+6
	db border_chr+7
	
gfx_petscii
	db $A0
	
	db $B0
	
	db $80			; invert chars
	
	db $6C,$E1,$7C,$E2,$7E
	
	db $71			; top background
	db $61			; stack background color
	db $66			; stack background character
	
	db $31			; shadow color
	
	db $13
	db $13

	db $CF,$F7,$D0,$E5,$EA,$CC,$EF,$FA

;eof